

                                   ###########ex 2.1#############

###crescexp  uma funcao para clculo do crescimento exponencial considerando crescimento contnuo e discreto###### 
###essa funo gera um grfico para comparao das curvas de crescimento contnuo e discreto##################

 crescexp<-function(tmax=50,n0=100,lamb=1.03,r=0.03)
 {
   result<-matrix(0,ncol=3,nrow=tmax)
   result[,1]<-1:tmax
   colnames(result)<-c("tempo","exp.contnuo","exp.discreto")
   result[1,c(2,3)]<-n0
   for(t in 2:tmax)
   {
     result[t,2]<-result[(t-1),2]*exp(r)
     result[t,3]<-result[(t-1),3]*lamb
   }
   plot(result[,1],result[,2],type="l",lty=2,xlab="tempo (t)",ylab="tamanho da poulao (n)")
   lines(result[,1],result[,3],lty=2,col="red")
   legend(locator(1),legend=c("crescimento contnuo", "crescimento discreto"),lty=c(1,2),col=c(1,2))
   return(result)
 }

##################################################################################################################################

###crescest  uma funo para clculo do crescimento exponencial a partir de um modelo determinstico e outro estocstico########
###essa funo gera um grfico para comparao das curvas dos modelos determinstico e estocstico##################

 crescest<-function(tmax=50,n0=100,var=0.01,r=0.03)
 {
   result<-matrix(0,ncol=3,nrow=tmax)
   result[,1]<-1:tmax
   colnames(result)<-c("tempo","exp.contnuo","exp.estocstico")
   result[1,c(2,3)]<-n0
   for(t in 2:tmax)
   {
     result[t,2]<-result[(t-1),2]*exp(r)
     result[t,3]<-result[(t-1),3]*exp(rnorm(1,r,sqrt(var)))
   }
   plot(result[,1],result[,2],type="l",lty=2,xlab="tempo (t)",ylab="tamanho da poulao (n)")
   lines(result[,1],result[,3],lty=2,col="red")
   legend(locator(1),legend=c("modelo determinstico", "modelo estocstico"),lty=c(1,2),col=c(1,2))
   return(result)
 }

###################################################################################################################################

###crescest2  uma funo igual a crescest porm no retorna os resultados nem gera grficos########
###essa funo  especial para plotagem simultnea de vrias curvas do modelo estocstico utilizando as linhas de comando abaixo###

 crescest2<-function(tmax=50,n0=100,var=0.01,r=0.03)
 {
   result<-matrix(0,ncol=3,nrow=tmax)
   result[,1]<-1:tmax
   colnames(result)<-c("tempo","exp.contnuo","exp.estocstico")
   result[1,c(2,3)]<-n0
   for(t in 2:tmax)
   {
     result[t,2]<-result[(t-1),2]*exp(r)
     result[t,3]<-result[(t-1),3]*exp(rnorm(1,r,sqrt(var)))
   }
    return(result)
 }

###linhas de comando para visualizar a sobreposio de 15 curvas de crescimento exponencial do modelo estocstico sobre o modelo determinstico##

proj2<-crescest2(var=0.01)
plot(proj2[,1],proj2[,2],type="l",lty=2,xlab="tempo (t)-M.det. em preto/M.estoc. em vermelho",ylab="tamanho da poulacao (n)-var=0.01")
for (i in 1:15)
{
proj2<-crescest2(var=0.01)
lines(proj2[,1],proj2[,3],lty=2,col="red")
}
